<?php

if (!defined('ABSPATH')) {
    die;
}

class Guaven_woo_search_admin
{
    public $woo_activeness;
    public $guaven_woos_firstrun;
    public $argv1;

    public function __construct()
    {
        if (get_option('guaven_woos_firstrun') == '') {
            $this->guaven_woos_firstrun = 1;
        }
    }

    public function run()
    {
        $this->save_settings();
        $cron_token = $this->cron_token();
        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/view.php';
    }

    public function save_settings()
    {
        if ($this->woo_activeness != 1) {
            add_settings_error('guaven_pnh_settings', esc_attr('settings_updated'), 'Error: Before the using this plugin, required WooCommerce plugin has to be active. Activate it, please, then come back here to continue', 'error');
        }
        if (get_option('guaven_woos_trend_table_done') == '') {
            $this->trend_db_construct();
            update_option('guaven_woos_trend_table_done', 1);
            add_settings_error('guaven_pnh_settings', esc_attr('settings_updated'), 'You can check the 1st QuickStart question&answer at FAQ tab to find out how easily start using the plugin', 'updated');
        }

        if (isset($_POST['guaven_woos_nonce_f']) and wp_verify_nonce($_POST['guaven_woos_nonce_f'], 'guaven_woos_nonce')) {
            $this->to_default_runner();
            add_settings_error('guaven_pnh_settings', esc_attr('settings_updated'), 'Success! All changes have been saved. Now just rebuild the cache.', 'updated');
        } elseif (isset($_POST['guaven_woos_reset_nonce_f']) and wp_verify_nonce($_POST['guaven_woos_reset_nonce_f'], 'guaven_woos_reset_nonce')) {
            $this->to_default_runner();
            add_settings_error('guaven_pnh_settings', esc_attr('settings_updated'), 'Success! All settings now same as they were preinstalled', 'updated');
        } elseif (!empty($this->guaven_woos_firstrun)) {
            $this->to_default_runner();
            update_option('guaven_woos_firstrun', 1);
        }
    }

    private function to_default_runner()
    {
        $this->is_checked('guaven_woos_corr_act', 'checked');
        $this->is_checked('guaven_woos_ispers', '');
        $this->is_checked('guaven_woos_nostock', '');
        $this->is_checked('guaven_woos_removehiddens', '');
        $this->string_setting('guaven_woos_variation_skus', '');
        $this->string_setting('guaven_woos_backend', '');
        $this->is_checked('guaven_woos_add_description_too', '');
        $this->is_checked('guaven_woos_add_shortdescription_too', '');
        $this->string_setting('guaven_woos_translit_data', '');

        $this->string_setting('guaven_show_all_text', '');
        $this->string_setting('guaven_woos_autorebuild', '');
        $this->string_setting('guaven_woos_rebuild_via', 'fs');
        $this->is_checked('guaven_woos_autorebuild_editor', '');

        $this->is_checked('guaven_woos_nomatch_pops', '');
        $this->string_setting('guaven_woos_popsmkey', 'total_sales');
        $this->string_setting('guaven_woos_popsmax', 5);

        $this->string_setting('guaven_woos_customorder', 'date');

        $this->is_checked('guaven_woos_catsearch', '');
        $this->string_setting('guaven_woos_catsearchmax', '5');
        $this->string_setting('guaven_woos_shown_taxonomies', 'product_cat');

        $this->string_setting('guaven_woos_large_data', '');
        $this->string_setting('guaven_woos_exactmatch', '');

        $this->string_setting('guaven_woos_perst', 'Recently Viewed Products');
        $this->string_setting('guaven_woos_persmax', '5');
        $this->string_setting('guaven_woos_pinneds', '');
        $this->string_setting('guaven_woos_pinneds_cat', '');
        $this->string_setting('guaven_woos_pinnedt', 'Featured products');
        $this->string_setting('guaven_woos_trendt', 'Trending products');
        $this->string_setting('guaven_woos_trend_days', '3');
        $this->string_setting('guaven_woos_trend_refresh', '10');
        $this->string_setting('guaven_woos_data_trend_num', 0);
        $this->string_setting('guaven_woos_maxres', '10');
        $this->string_setting('guaven_woos_maxprod', '10000');
        $this->string_setting('guaven_woos_sugbarwidth', '100');
        $this->string_setting('guaven_woos_showinit_t', 'Find your product with fast search. Enter some keyword such as iphone, samsung, wear etc.');
        $this->string_setting('guaven_woos_showinit_n', 'No product found by your keyword');

        $this->string_setting('guaven_woos_customfields', '');
        $this->string_setting('guaven_woos_excluded_cats', '');
        $this->string_setting('guaven_woos_excluded_prods', '');
        $this->string_setting('guaven_woos_customtags', '');
        $this->string_setting('guaven_woos_wootags', '');
        $this->string_setting('guaven_woos_custom_css', '');
        $this->string_setting('guaven_woos_custom_js', '');
        $this->string_setting('guaven_woos_selector', '[name="s"]');
        $this->string_setting('guaven_woos_filter_selector', '');
        $this->string_setting('guaven_woos_synonyms', '');
        $this->string_setting('guaven_woos_async', '');

        $this->is_checked('guaven_woos_permalink', '');
        $this->is_checked('guaven_woos_highlight', '');
        $this->is_checked('guaven_woos_disable_meta_correction', '');
        $this->string_setting('guaven_woos_ignorelist', '');
        $this->string_setting('guaven_woos_thumb_quality', 'thumbnail');

        $this->string_setting('guaven_woos_layout', addslashes($this->default_layout()));
        $this->string_setting('guaven_woos_min_symb_sugg', '3');
        $this->int_setting('guaven_woos_whentypo');
        $this->is_checked('guaven_woos_taxes', '');
        $this->is_checked('guaven_woos_mobilesearch', '');
        $this->is_checked('guaven_woos_numberformat', '');
    }

    private function is_checked($par, $defval = '')
    {
        if (isset($_POST[$par])) {
            $k = 'checked';
        } elseif (empty($_POST['guaven_woos_nonce_f']) and $defval != '') {
            $k = $defval;
        } else {
            $k = '';
        }
        update_option($par, $k);
    }

    private function string_setting($par, $def)
    {
        if (!empty($_POST[$par])) {
            $k = $_POST[$par];
        } else {
            $k = $def;
        }
        update_option($par, $k);
    }

    private function int_setting($par)
    {
        if (!empty($_POST[$par])) {
            $k = (int) $_POST[$par];
        } else {
            $k = 0;
        }
        update_option($par, $k);
    }

    public function default_layout()
    {
        return '<a href="{url}"><div class="guaven_woos_div"><img class="guaven_woos_img" src="{imgurl}"></div><div class="guaven_woos_titlediv"><span>{title}</span><br><small>{price} {saleprice}</small></div></a>';
    }

    public function cron_token()
    {
        $ret = get_option('guaven_woos_cronkey');
        if ($ret == '') {
            $ret = uniqid(time());
            update_option('guaven_woos_cronkey', $ret);
        }

        return $ret;
    }


    private function dont_do_rebuild()
    {
        $check_perm = get_option('guaven_woos_autorebuild');
        if ($check_perm == '') {
            $check_perm = 'b1a0';
        }
        $check_editor_role = get_option('guaven_woos_autorebuild_editor');
        if ($check_perm == 'b0a0') {
            return '0';
        } elseif (!current_user_can('manage_woocommerce')) {
            return '0';
        } elseif ($check_editor_role == '' and !current_user_can('manage_options')) {
            return '0';
        }

        return $check_perm;
    }

    public function edit_hook_rebuilder()
    {
        if ($this->dont_do_rebuild() == '0' or $this->dont_do_rebuild() == 'b1a0') {
            return;
        }
        global $post;
        if (!empty($post->post_type) and $post->post_type == 'product') {
            update_option('do_woosearchbox_rebuild', time());
        }
    }

    public function do_rebuilder_at_footer()
    {
        if ($this->dont_do_rebuild() == '0') {
            return;
        }

        echo '<script>
    woos_dontclose=0;
    woos_data = {
      "action": "cache_rebuild_ajax",
      "ajnonce": "' . wp_create_nonce('cache_rebuild_ajax') . '"
  };
window.onbeforeunload=function(){if (woos_dontclose==0) return; return "Cache rebuilding process is in progress... Are you sure to cancel it and close the page?";}
  jQuery(".rebuilder").click(function($) {
    jQuery("#result_field").html("0% done...");
      guaven_woos_start_rebuild(woos_data);
  });
    function guaven_woos_start_rebuild(data) {
        jQuery(".Rebuild-SearchBox-Cache a").text("Rebuilding started...");
        jQuery(".inputrebuilder").val("Rebuilding started...");
        jQuery("#result_field").css("display","block");
        woos_dontclose=1;
       jQuery.post(ajaxurl, data, function(response) {
              jQuery("#result_field").html(response+"% done...");
               if (response.indexOf("success_message") ==-1) {console.log("Woo Search Box Cache Rebuilding: "+response+"% done...");guaven_woos_start_rebuild(data);}
               else { jQuery("#result_field").html(response);
                 jQuery(".Rebuild-SearchBox-Cache a").text("Rebuilding done!");
                 jQuery(".inputrebuilder").val("Rebuilding done!");
                 woos_dontclose=0;
                 console.log("Woo Search Box Cache Rebuilding has been completed!"); }
           }).fail(function() {
             jQuery("#result_field").html("Internal Server Error happened while building the cache data. It can be because of some limits of your server. Please contact to the plugin support team.");
             jQuery("#result_field").css("background","red");
             jQuery(".Rebuild-SearchBox-Cache a").text("Rebuilding failed!");
             jQuery(".inputrebuilder").val("Rebuilding failed!");
  });
    }
';
        if (get_option('do_woosearchbox_rebuild') != '') {
            echo 'guaven_woos_start_rebuild(woos_data);';
        }
        echo '
jQuery(".Rebuild-SearchBox-Cache a").attr("href","javascript://");
</script>
  <style>.Rebuild-SearchBox-Cache a {background:#008ec2 !important}</style>';
    }


    public function woos_rebuild_top_button($wp_admin_bar)
    {
        if ($this->dont_do_rebuild() == '0' or $this->dont_do_rebuild() == 'b0a1' or !is_admin()) {
            return;
        }
        $args = array(
            'id' => 'my_page',
            'title' => 'Rebuild SearchBox Cache',
            'href' => 'javascript://',
            'meta' => array(
                'class' => 'Rebuild-SearchBox-Cache rebuilder'
            )
        );
        $wp_admin_bar->add_node($args);
    }


    public function cache_rebuild_ajax_callback()
    {
        $step_size = 100;

        global $wpdb;
        $pcount = $wpdb->get_var("select count(*) from $wpdb->posts where post_status='publish' and post_type='product'");

        if ($this->argv1 == $this->cron_token()) {
            $step_size = $pcount;
        } else {
            check_ajax_referer('cache_rebuild_ajax', 'ajnonce');
        }

        $mcount = (get_option('guaven_woos_maxprod') > 0 ? get_option('guaven_woos_maxprod') : 10000);
        $pcount = min($mcount, $pcount);

        $all_steps = ceil($pcount / $step_size);

        $msteps = (int) get_transient('guaven_woos_crs') + 1;

        $offset = $step_size * ($msteps - 1);

        if ($msteps == 1) {
            $this->cache_clean();

            $this->cache_rebuilder(0, array(), $step_size, 'guaven_woos_pinned_cache');

            if (get_option('guaven_woos_nomatch_pops') != '') {
                $max_pops_size = get_option('guaven_woos_maxres');
                $this->cache_rebuilder(0, array(), $max_pops_size, 'guaven_woos_populars_cache');
            }

            if (get_option('guaven_woos_catsearch') != '') {
                $max_pops_size    = get_option('guaven_woos_maxres');
                $shown_taxonomies = (get_option('guaven_woos_shown_taxonomies') == '') ? array(
                    'product_cat'
                ) : explode(",", get_option('guaven_woos_shown_taxonomies'));
                foreach ($shown_taxonomies as $key => $value) {
                    if ($value != '') {
                        $this->cache_category_rebuilder($value);
                    }
                }
            }
        }

        if ($this->fs_or_db() != '') {
            $old_option_data = unserialize(file_get_contents($this->fs_or_db()));
        } else {
            $old_option_data = unserialize(get_option('guaven_woos_product_cache'));
        }

        if (!is_array($old_option_data)) {
            $old_option_data = array();
        }

        set_transient('guaven_woos_crs', $msteps, 3600);

        $this->cache_rebuilder($offset, $old_option_data, $step_size, 'guaven_woos_product_cache', $pcount);

        if ($all_steps <= $msteps) {
            $final_version_for_js = $this->cache_final_prepare();

            $guaven_woows_jsfile = GUAVEN_WOO_SEARCH_PLUGIN_PATH . 'public/assets/guaven_woos_data.js';
            if (is_writable(GUAVEN_WOO_SEARCH_PLUGIN_PATH . 'public/assets/')) {
                file_put_contents($guaven_woows_jsfile, $final_version_for_js);
                chmod($guaven_woows_jsfile, 0777);
                update_option('guaven_woos_nojsfile', '');
                update_option('guaven_woos_product_cache', '');
                delete_transient('guaven_woos_data_trend');
                echo 'Cache Data has successfully been generated.<br>';
            } else {
                echo '<b>Notice: </b> Your plugins folder is not writable by the system. That\'s why generated js data will be
            printed in your html code, not in separated js file.(it works in both cases, so don\'t worry) If you want to held js data separately, just make your plugins folder
            writable and then Rebuild the Cache again.<br><br>';
                update_option('guaven_woos_nojsfile', 1);
            }

            update_option('guaven_woos_js_data', $final_version_for_js, false);
            echo '<span class="success_message"></span>';

            $js_css_version = (int) get_option('guaven_woos_jscss_version') + 1;
            update_option('guaven_woos_jscss_version', $js_css_version);
            update_option('do_woosearchbox_rebuild', '');
            delete_transient('guaven_woos_crs');
            wp_die();
        }

        echo round($msteps * 10000 / $all_steps) / 100;

        wp_die();
    }

    public function transient_cleaner()
    {
        //removes old transients created by this plugin
    }

    private function cache_clean()
    {
        if ($this->fs_or_db() != '') {
            file_put_contents($this->fs_or_db(), '');
        }
        update_option('guaven_woos_product_cache', '');
        update_option('guaven_woos_pinned_cache', '');
    }

    private function cache_rebuilder($offset, $old_option_data, $step_size, $op_name = 'guaven_woos_product_cache', $totalproducts = 0)
    {
        $args = array(
            'post_type' => 'product',
            'posts_per_page' => $step_size,
            'offset' => $offset,
            'suppress_filters' => true
        );

        if (get_option('guaven_woos_variation_skus') == 2) {
            $args['post_type']      = array(
                'product',
                'product_variation'
            );
            $skip_parent_variations = 1;
        }
        if (get_option('guaven_woos_customorder') != '') {
            $custom_order = get_option('guaven_woos_customorder');

            if (strpos($custom_order, 'meta:') !== false) {
                $args['meta_key'] = substr($custom_order, 5);
                if (strpos($args['meta_key'], 'count') !== false or strpos($args['meta_key'], 'price') !== false) {
                    $args['orderby'] = 'meta_value_num';
                } else {
                    $args['orderby'] = 'meta_value';
                }
            } else {
                $args['orderby'] = $custom_order;
            }
            $args['order'] = 'DESC';
        }

        if ($op_name == 'guaven_woos_pinned_cache') {
            $pinstoimplode    = get_option('guaven_woos_pinneds');
            $args['post__in'] = explode(',', $pinstoimplode);
        } elseif ($op_name == 'guaven_woos_populars_cache') {
            $popviews = get_option('guaven_woos_popsmkey');
            if ($popviews != '') {
                $args['meta_key']       = $popviews;
                $args['orderby']        = 'meta_value_num';
                $args['order']          = 'DESC';
                $args['posts_per_page'] = get_option('guaven_woos_popsmax');
            }
        }

        if (get_option('guaven_woos_nostock') == '') {
            $args['meta_query'] = array(
                array(
                    'key' => '_stock_status',
                    'value' => 'outofstock',
                    'compare'=>'!='
                )
            );
        }



        $hiddenquery_fortaxquery = array();
        if (get_option('guaven_woos_removehiddens') != '') {
            if ($this->get_wc_version() == 2) {
                $args['meta_query'][] = array(
                    'key' => '_visibility',
                    'value' => 'hidden',
                    'compare' => '!='
                );
            }
        }

        if (get_option('guaven_woos_excluded_cats') != '') {
            $excludedquery_fortaxquery = array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => explode(",", preg_replace("/[^0-9,.]/", "", get_option('guaven_woos_excluded_cats'))),
                'operator' => 'NOT IN'
            );
        } else {
            $excludedquery_fortaxquery = array();
        }


        if (!empty($excludedquery_fortaxquery)) {
            $args['tax_query'] = array(
                $excludedquery_fortaxquery
            );
        }

        if (get_option('guaven_woos_excluded_prods') != '') {
            $args['post__not_in'] = explode(",", get_option('guaven_woos_excluded_prods'));
        }
        if (get_option('guaven_woos_removehiddens') != '' and $this->get_wc_version() == 3) {
            $args_temp = array();
            if (!empty($args['post__not_in'])) {
                $args_temp = $args['post__not_in'];
            }
            $args['post__not_in'] = array_merge($this->get_hidden_products(), $args_temp);
        }

        $products_for_json = get_posts($args);
        $products_array    = $this->json_processing($products_for_json);
        if ($op_name == 'guaven_woos_product_cache' and $this->fs_or_db() != '') {
            file_put_contents($this->fs_or_db(), serialize(array_merge($old_option_data, $products_array)));
            return;
        }
        update_option($op_name, serialize(array_merge($old_option_data, $products_array)), false);
    }



    public function json_processing($products_for_json)
    {
        $products_array = array();
        $translit_data  = get_option('guaven_woos_translit_data');
        if (get_option('guaven_woos_taxes') != '') {
            $guaven_woos_taxenabled = 1;
        } else {
            $guaven_woos_taxenabled = 0;
        }
        $permalink_structure = get_option('guaven_woos_permalink');
        $number_format       = get_option('guaven_woos_numberformat') != '' ? 0 : 2;

        foreach ($products_for_json as $key => $value) {
            $_product = wc_get_product($value->ID);
            if (empty($_product) or (isset($skip_parent_variations) and $this->get_product_type($_product) == 'variable')) {
                continue;
            }
            //wpml part from v1.2.4
            $langfixer_arr        = $this->langfixer($value);
            $langfixer            = $langfixer_arr[0];
            $guaven_woos_wpml_key = $langfixer_arr[1];
            //end of wpml part

            $title_translit = '';
            if ($translit_data == '1') {
                $title_translit = $this->translitter($value->post_title);
                if ($title_translit != mb_strtolower($value->post_title)) {
                    $title_translit = '<span class="gwstrn">' . $title_translit . '</span>';
                } else {
                    $title_translit = '';
                }
            }

            $title_and_hidden_sku = addslashes($value->post_title . ' <span class="woos_sku"> ' . get_post_meta($value->ID, '_sku', true) . (strpos(get_post_meta($value->ID, '_sku', true), ' ') !== false ? (', ' . str_replace(" ", "", get_post_meta($value->ID, '_sku', true))) : '') . ' </span>' . $guaven_woos_wpml_key);

            if (get_option('guaven_woos_variation_skus') == 1) {
                //gather variation sku-s
                global $wpdb;
                $variation_skus_str = '';
                $variation_skus     = $wpdb->get_results("select a.meta_value as mv from $wpdb->postmeta a inner join $wpdb->posts b on a.post_id=b.ID
where meta_key='_sku' and b.post_type='product_variation' and b.post_parent=" . intval($value->ID));
                foreach ($variation_skus as $vskkey) {
                    $variation_skus_str .= $vskkey->mv . ', ' . (strpos($vskkey->mv, ' ') !== false) ? str_replace(" ", "", $vskkey->mv) . ', ' : '';
                }
                if ($variation_skus_str != '') {
                    $title_and_hidden_sku .= addslashes(' <span class="woos_sku woos_sku_variations"> ' . substr($variation_skus_str, 0, -2) . ' </span>');
                }
            }

            $add_description_too = get_option('guaven_woos_add_description_too');
            if ($add_description_too) {
                $title_and_hidden_sku .= preg_replace('/[\x00-\x1F\x80-\xFF]/', '', addslashes(' <span class="guaven_woos_hidden_description"> ' . preg_replace('/\s+/', ' ', trim(strip_tags($value->post_content))) . ' </span>'));
            }

            $guaven_woos_add_shortdescription_too = get_option('guaven_woos_add_shortdescription_too');
            if ($guaven_woos_add_shortdescription_too) {
                $title_and_hidden_sku .= preg_replace('/[\x00-\x1F\x80-\xFF]/', '', addslashes(' <span class="guaven_woos_hidden_description gwsbsd"> ' . preg_replace('/\s+/', ' ', trim(strip_tags($value->post_excerpt))) . ' </span>'));
            }

            $add_tags_too    = get_option('guaven_woos_customtags');
            $add_wootags_too = get_option('guaven_woos_wootags');
            if ($add_tags_too != '' or $add_wootags_too != '') {
                $taxes_tba      = array_merge(explode(',', $add_tags_too), explode(',', $add_wootags_too));
                $tba_searchdata = ' ';
                foreach ($taxes_tba as $ttba) {
                    if ($ttba != '') {
                        $term_list_itstag = 0;
                        $term_list        = wp_get_post_terms($value->ID, $ttba);
                        foreach ($term_list as $term_single) {
                            if (!empty($term_single->name) and strpos($tba_searchdata, $term_single->name) === false) {
                                $tba_searchdata .= $term_single->name . ' ';
                                $term_list_itstag = 1;
                            }
                            if ($term_single->parent > 0) {
                                $pterm = get_term($term_single->parent);
                                if (strpos($tba_searchdata, $pterm->name) === false) {
                                    $tba_searchdata .= $pterm->name . ' ';
                                }
                            }
                        }
                        if ($term_list_itstag == 0 and strpos($ttba, 'pa_') === 0) {
                            $term_list_custom = $_product->get_attribute(str_replace("pa_", "", $ttba));
                            $tba_searchdata .= $term_list_custom . ' ';
                        }
                    }
                }
                $title_and_hidden_sku .= addslashes(' <span class="guaven_woos_hidden guaven_woos_hidden_tags"> ' . $tba_searchdata . ' </span>');
            }

            $custom_fields             = get_option('guaven_woos_customfields');
            $custom_fields_search_data = '';
            if ($custom_fields != '') {
                $cf_arr = explode(',', $custom_fields);
                foreach ($cf_arr as $cf_arr_el) {
                    if ($cf_arr_el != '') {
                        $tempstrarr = get_post_meta($value->ID, $cf_arr_el, true);
                        if (is_array($tempstrarr)) {
                            $tempstrarr = json_encode($tempstrarr);
                        }
                        $custom_fields_search_data .= ' ' . $tempstrarr;
                        if (get_option('guaven_woos_variation_skus') == 1) {
                            $custom_fields_search_data .= ' ' . $this->add_variations_metadata($value->ID, $cf_arr_el);
                        }
                    }
                }
                $title_and_hidden_sku .= addslashes(' <span class="guaven_woos_hidden"> ' . $custom_fields_search_data . ' </span>');
            }

            $add_synonyms_too = get_option('guaven_woos_synonyms');
            if ($add_synonyms_too != '') {
                $ptitle           = get_the_title($value->ID) . ($custom_fields_search_data != '' ? ' ' . $custom_fields_search_data : '') . ($tba_searchdata != '' ? ' ' . $tba_searchdata : '');
                $corresp_synonyms = $this->synonym_list($add_synonyms_too, $ptitle);
                if ($corresp_synonyms != '') {
                    $title_and_hidden_sku .= addslashes(' <span class="gwshd"> ' . str_replace(array(
                        "'",
                        '"',
                        '’'
                    ), '', stripslashes($corresp_synonyms)) . ' </span>');
                }
            }

            $title_and_hidden_sku .= $title_translit;

            $vterms          = get_the_terms($value->ID, 'product_cat');
            $vproduct_cat_id = array();
            foreach ($vterms as $vterm) {
                $vproduct_cat_id[] = $vterm->term_id;
                //if (!empty($vterm->parent) and $vterm->parent>0) $vproduct_cat_id[] = $vterm->parent;
            }
            $title_and_hidden_sku .= (' <span class="gwshd">~' . implode('~', $vproduct_cat_id) . '~</span>');

            $thumb_quality              = get_option('guaven_woos_thumb_quality') != '' ? get_option('guaven_woos_thumb_quality') : 'thumbnail';
            $products_array[$value->ID] = $this->price_and_parparser($value, $langfixer, $_product, $guaven_woos_taxenabled, $title_and_hidden_sku, $permalink_structure, $number_format, $thumb_quality);
        }
        return $products_array;
    }




    public function enqueue()
    {
        $vers = intval(get_option('guaven_woos_jscss_version'));
        wp_enqueue_script('guaven_woos_admin', plugin_dir_url(__FILE__) . 'assets/guaven_woos_admin.js?v=' . $vers, array(
            'jquery'
        ), true);
        wp_enqueue_style('guaven_woos_admin', plugin_dir_url(__FILE__) . 'assets/guaven_woos_admin.css?v=' . $vers, true);
        if (!isset($_GET['page']) or strpos($_GET['page'], 'class-search-analytics') === false) {
            return;
        }
        wp_enqueue_script('guaven_woos_chartist', plugin_dir_url(__FILE__) . 'assets/chartist.min.js');
        wp_enqueue_style('guaven_woos_chartist', plugin_dir_url(__FILE__) . 'assets/chartist.min.css');
    }



    public function langfixer($value)
    {
        $guaven_woos_wpml_key = '';
        $langfixer            = '';
        if (defined('ICL_LANGUAGE_CODE')) {
            // $woos_post_lan = wpml_get_language_information($value->ID);
            $woos_post_lan = apply_filters('wpml_post_language_details', null, $value->ID);
            if (is_array($woos_post_lan)) {
                $guaven_woos_wpml_key = ' <span id="woolan_' . $woos_post_lan['language_code'] . '"></span>';
                $langfixer            = '&lang=' . $woos_post_lan['language_code'];
            }
        }
        return array(
            $langfixer,
            $guaven_woos_wpml_key
        );
    }



    public function price_and_parparser($value, $langfixer, $_product, $guaven_woos_taxenabled, $title_and_hidden_sku, $permalink_structure, $number_format, $thumb_quality)
    {
        if ($this->get_product_type($_product) == 'variable') {
            if ($guaven_woos_taxenabled == 0) {
                $taxenabled = false;
            } else {
                $taxenabled = true;
            }
            $varprices = $_product->get_variation_prices($taxenabled);

            if (!empty($varprices['regular_price'])) {
                $_regular_price = strip_tags(wc_price(min($varprices['regular_price'])) . ' – ' . wc_price(max($varprices['regular_price'])));
                if (min($varprices['regular_price']) == max($varprices['regular_price'])) {
                    $_regular_price = strip_tags(wc_price(min($varprices['regular_price'])));
                }
            } else {
                $_regular_price = '';
            }
            if (!empty($varprices['sale_price']) and min($varprices['sale_price']) > 0) {
                $_sale_price = strip_tags(wc_price(min($varprices['sale_price'])) . ' – ' . wc_price(max($varprices['sale_price'])));
                if (min($varprices['sale_price']) == max($varprices['sale_price'])) {
                    $_sale_price = strip_tags(wc_price(min($varprices['sale_price'])));
                }
            } else {
                $_sale_price = '';
            }
            if ($_sale_price == $_regular_price) {
                $_sale_price = '';
            } else {
                $_regular_price = '<del>' . $_regular_price . '</del>';
            }
        } else {
            if ($guaven_woos_taxenabled == 0) {
                $_regular_price = get_post_meta($value->ID, '_regular_price', true);
                if ((int) $_regular_price == 0) {
                    $_regular_price = get_post_meta($value->ID, '_price', true);
                }
                $_sale_price = get_post_meta($value->ID, '_sale_price', true);
            } else {
                $_regular_price = $_product->get_price_including_tax(1, $_product->get_regular_price());
                $_sale_price    = $_product->get_price_including_tax();
            }
            if ($_sale_price == $_regular_price) {
                $_sale_price = '';
            }
        }


        $check_sale_start = (int) strtotime(get_post_meta($value->ID, '_sale_price_dates_from', true));
        $sale_expiration  = (int) strtotime(get_post_meta($value->ID, '_sale_price_dates_to', true)) - time();
        $sale_start       = $check_sale_start - time();
        $sale_meta        = ($check_sale_start == 0 or ($sale_start < 0 and $sale_expiration > 0)) ? $_sale_price : '';

        if ($_regular_price > 0) {
            $_regular_price = addslashes(wc_price((float) str_replace(",", ".", $_regular_price), array(
                'decimals' => $number_format
            )));
        }
        if ($sale_meta > 0) {
            $sale_meta = addslashes(wc_price((float) str_replace(",", ".", $sale_meta), array(
                'decimals' => $number_format
            )));
        }
        if ($permalink_structure == '') {
            $perlink = 'gwp=' . $value->ID . $langfixer;
        } else {
            $perlink = get_permalink($value->ID);
        }

        $thumbid = get_post_thumbnail_id($value->ID);

        $length         = get_post_meta($value->ID, '_length', true);
        $weight         = get_post_meta($value->ID, '_weight', true);
        $height         = get_post_meta($value->ID, '_height', true);
        $width          = get_post_meta($value->ID, '_width', true);
        $total_sales    = get_post_meta($value->ID, 'total_sales', true);
        $stock_quantity = get_post_meta($value->ID, '_stock', true);
        if (!empty($stock_quantity)) {
            $stock_quantity = (int) $stock_quantity;
        }
        if ($this->get_product_type($_product) == 'variable') {
            $add_to_cart = 'href=\"#\" style=\"display:none\" ';
        } else {
            $add_to_cart = 'href=\"?post_type=product&add-to-cart=' . $value->ID . '\" class=\"gwsq_' . get_post_meta($value->ID, '_stock_status', true) . '\" data-product_id=\"' . $value->ID . '\" rel=\"nofollow\" data-quantity=\"1\"';
        }

        $product_cat_arr = get_the_terms($value->ID, 'product_cat');
        if (!empty($product_cat_arr[0]->term_id)) {
            $product_cat = addslashes('<a href="' . get_term_link($product_cat_arr[0]->term_id, 'product_cat') . '">' . $product_cat_arr[0]->name . '</a>');
        }

        if (!empty($thumbid)) {
            $thumber_arr = wp_get_attachment_image_src($thumbid, $thumb_quality);
            $thumber     = $thumber_arr[0];
        } else {
            $thumber = addslashes(wc_placeholder_img_src());
        }

        $products_array = array(
            'ID' => $value->ID,
            'thumb' => $thumber,
            'url' => $perlink,
            'title' => $title_and_hidden_sku,
            'price' => $_regular_price,
            'sale' => $sale_meta,
            'length' => $length,
            'weight' => $weight,
            'height' => $height,
            'width' => $width,
            'total_sales' => $total_sales,
            'stock_quantity' => $stock_quantity,
            'add_to_cart' => $add_to_cart,
            'product_cat' => $product_cat
        );
        return $products_array;
    }

    public function synonym_list($add_synonyms_too, $ptitle)
    {
        $corresp_synonyms = array();
        $synonym_list     = explode(',', $add_synonyms_too);
        $synonym_list_res = array();
        $title_elements   = explode(' ', addslashes(strtolower($ptitle)));
        foreach ($synonym_list as $syn) {
            $syn_lr = explode('-', strtolower($syn));

            if (in_array(trim(str_replace("_", "-", $syn_lr[0])), $title_elements) or (strpos($ptitle, ' ') !== false and strpos(addslashes(strtolower($ptitle)), trim(str_replace("_", "-", $syn_lr[0]))) !== false)) {
                $synonym_list_res[] = trim(str_replace("_", "-", $syn_lr[1]));
            } elseif (in_array(trim(str_replace("_", "-", $syn_lr[1])), $title_elements) or (strpos($ptitle, ' ') !== false and strpos(addslashes(strtolower($ptitle)), trim(str_replace("_", "-", $syn_lr[1]))) !== false)) {
                $synonym_list_res[] = trim(str_replace("_", "-", $syn_lr[0]));
            }
        }

        return implode(',', $synonym_list_res);
    }

    private function cache_category_rebuilder($tip)
    {

        //update_option('guaven_woos_category_parent',16); //should be run in special cases
        $pcats_arg = array(
            'taxonomy' => $tip, // >=WP 4.5.0
            'hide_empty' => false,
            'number' => 1000
        );
        if (get_option('guaven_woos_category_parent') != '') {
            $pcats_arg['parent'] = (int) get_option('guaven_woos_category_parent');
        } //should be none in most cases
        $pcats = get_terms($tip, $pcats_arg);

        $products_cats_array = array();
        foreach ($pcats as $key => $value) {
            $products_cats_array[$value->term_id] = array(
                'ID' => $value->term_id,
                'title' => $value->name,
                'slug' => $value->slug,
                'parent' => $value->parent,
                'description' => $value->description
            );
        }
        $tip = preg_replace("/[^A-Za-z0-9 ]/", '', $tip);
        update_option('guaven_woos_' . $tip . '_cache', serialize($products_cats_array));
    }

    private function cache_featured_category($termids)
    {
        if (empty($termids)) {
            return;
        }
        $termids             = explode(",", $termids);
        $pcats_arg           = array(
            'taxonomy' => 'product_cat', // >=WP 4.5.0
            'hide_empty' => false,
            'include' => $termids
        );
        $pcats               = get_terms('product_cat', $pcats_arg);
        $ret                 = '';
        $products_cats_array = array();
        foreach ($pcats as $key => $value) {
            $products_cats_array = array(
                'ID' => $value->term_id,
                'title' => $value->name,
                'slug' => $value->slug,
                'parent' => $value->parent,
                'description' => $value->description
            );
            $ret .= '<li class=\"gwspc\">' . $this->parse_template($products_cats_array, 'taxonomy:product_cat') . '</li>';
        }
        return $ret;
    }

    public function cache_final_prepare()
    {
        if ($this->fs_or_db() != '') {
            $guaven_woos_product_cache = unserialize(file_get_contents($this->fs_or_db()));
        } else {
            $guaven_woos_product_cache = unserialize(get_option('guaven_woos_product_cache'));
        }

        $guaven_woos_pinned_cache   = unserialize(get_option('guaven_woos_pinned_cache'));
        $guaven_woos_populars_cache = unserialize(get_option('guaven_woos_populars_cache'));

        $guaven_woos_category_cache = unserialize(get_option('guaven_woos_category_cache'));

        $cache_li_loop_main        = $this->cache_li_loop($guaven_woos_product_cache);
        $cache_li_loop_pinned      = $this->cache_li_loop($guaven_woos_pinned_cache);
        $cache_li_loop_pops        = $this->cache_li_loop($guaven_woos_populars_cache);
        $cache_li_loop_pinned_cats = $this->cache_featured_category(get_option('guaven_woos_pinneds_cat'));

        $shown_taxonomies = (get_option('guaven_woos_shown_taxonomies') == '') ? array(
            'product_cat'
        ) : explode(",", get_option('guaven_woos_shown_taxonomies'));
        $cat_html_data    = '';
        $cat_extend_data  = array();

        foreach ($shown_taxonomies as $key => $value) {
            $value_raw                  = $value;
            $value                      = preg_replace("/[^A-Za-z0-9 ]/", '', $value);
            $guaven_woos_category_cache = unserialize(get_option('guaven_woos_' . $value . '_cache'));
            if (!empty($value)) {
                $cache_li_loop_cats = $this->cache_li_loop($guaven_woos_category_cache, 'taxonomy:' . $value_raw);
            }
            $cat_html_data .= 'var guaven_woos_' . $value . '_html={' . $cache_li_loop_cats[0] . '};
var guaven_woos_' . $value . '_keywords={' . $cache_li_loop_cats[1] . '};
';
            $cat_extend_data['html'][]    = 'guaven_woos_' . $value . '_html';
            $cat_extend_data['keyword'][] = 'guaven_woos_' . $value . '_keywords';
        }
        if (count($cat_extend_data['html']) == 1) {
            $cat_extend_data['final'] = 'var guaven_woos_category_keywords=' . $cat_extend_data['keyword'][0] . ';
var guaven_woos_category_html=' . $cat_extend_data['html'][0] . ';
';
        } else {
            $cat_extend_data['final'] = 'var guaven_woos_category_keywords=jQuery.extend(' . implode(',', $cat_extend_data['keyword']) . ');
 var guaven_woos_category_html=jQuery.extend(' . implode(',', $cat_extend_data['html']) . ');';
        }
        return 'var guaven_woos_cache_html={' . $cache_li_loop_main[0] . '};
var guaven_woos_cache_keywords={' . $cache_li_loop_main[1] . '};
var guaven_woos_pinned_html={' . $cache_li_loop_pinned[0] . '};
var guaven_woos_pinned_keywords={' . $cache_li_loop_pinned[1] . '};
var guaven_woos_pinned_cat_html="' . $cache_li_loop_pinned_cats . '";
var guaven_woos_populars_html={' . $cache_li_loop_pops[0] . '};
var guaven_woos_populars_keywords={' . $cache_li_loop_pops[1] . '};
' . $cat_html_data . '
' . $cat_extend_data['final'];
    }

    public function cache_li_loop($guaven_woos_product_cache, $tip = '')
    {
        $gwsi        = 0;
        $htmlkeys    = '';
        $keywordkeys = '';
        if (is_array($guaven_woos_product_cache)) {
            foreach ($guaven_woos_product_cache as $guaven_woos_pck => $guaven_woos_pcv) {
                ++$gwsi;
                $htmlkeys .= '"' . $guaven_woos_pck . '":"   ' . $this->results_layout($tip, $gwsi, $guaven_woos_pcv["ID"], $this->parse_template($guaven_woos_pcv, $tip)) . '"';

                $keywordkeys .= '"' . $guaven_woos_pck . '": "' . str_replace(array(
                    "\n",
                    "\r"
                ), '', addslashes(stripslashes($guaven_woos_pcv['title']))) . '"';
                if ($gwsi < count($guaven_woos_product_cache)) {
                    $htmlkeys .= ',' . PHP_EOL;
                    $keywordkeys .= ',' . PHP_EOL;
                }
            }
        } else {
            return array(
                '',
                ''
            );
        }
        $htmlkeys    = str_replace(array(
            '  <li class=\"guaven_woos_suggestion_list' . $tip . '\" tabindex=\"',
            '\"><div class=\"guaven_woos_div\"><img class=\"guaven_woos_img\" src=\"',
            '\"></div><div class=\"guaven_woos_titlediv\">',
            '</div></a> </li>',
            '<span class=\"woocommerce-Price-amount amount\"><span class=\"woocommerce-Price-currencySymbol\">',
            '</span>',
            '<small>',
            '</small>'
        ), array(
            '{{l}}',
            '{{d}}',
            '{{i}}',
            '{{e}}',
            '{{c}}',
            '{{p}}',
            '{{m}}',
            '{{a}}'
        ), $htmlkeys);
        $keywordkeys = str_replace(array(
            '</span> <span class=\"guaven_woos_hidden guaven_woos_hidden_tags\">',
            '</span> <span class=\"gwshd\">',
            '</span> <span class=\"woos_sku woos_sku_variations\">',
            '</span><span class=\"gwstrn\">',
            '</span>'
        ), array(
            '{{s}}',
            '{{g}}',
            '{{v}}',
            '{{w}}',
            '{{p}}'
        ), $keywordkeys);
        return array(
            $htmlkeys,
            $keywordkeys
        );
    }

    public function parse_template($guaven_woos_pcv, $tip = '')
    {
        if (strpos($tip, 'taxonomy:') === 0) {
            $tip      = str_replace("taxonomy:", "", $tip);
            $parcat_s = '';
            if (!empty($guaven_woos_pcv['parent']) and $guaven_woos_pcv['parent'] > 0) {
                $parcat   = get_term($guaven_woos_pcv['parent']);
                $parcat_s = '<span class="woos_cat_par_span">' . $parcat->name . ' / </span>';
            }
            $pclink = get_term_link($guaven_woos_pcv['slug'], $tip);
            if (is_wp_error($pclink)) {
                return;
            } //for rare cases
            return '<a class=\"guaven_woos_titlediv_cat\" href=\"' . $pclink . '\">' . addslashes($parcat_s . $guaven_woos_pcv['title']) . '</a>';
        }

        $saleprice = $guaven_woos_pcv['sale'];
        $price     = $guaven_woos_pcv['price'];
        if ($saleprice != '') {
            $price = '<del>' . $price . '</del>';
        }
        $currency_regular = ''; //deprecated
        $currency_sale    = ''; //deprecated

        $wpuploaddir = wp_upload_dir();
        $find        = array(
            '{url}',
            '{title}',
            '{imgurl}',
            '{price}',
            '{saleprice}',
            '{currency_regular}',
            '{currency_sale}',
            '{length}',
            '{height}',
            '{weight}',
            '{width}',
            '{total_sales}',
            '{stock_quantity}',
            '{add_to_cart}',
            '{product_cat}'
        );
        $replace     = array(
            $guaven_woos_pcv['url'],
            str_replace(array(
                "\n",
                "\r"
            ), '', $guaven_woos_pcv['title']),
            $guaven_woos_pcv['thumb'],
            $price,
            $saleprice,
            $currency_regular,
            $currency_sale,
            isset($guaven_woos_pcv['length']) ? $guaven_woos_pcv['length'] : '',
            isset($guaven_woos_pcv['height']) ? $guaven_woos_pcv['height'] : '',
            isset($guaven_woos_pcv['weight']) ? $guaven_woos_pcv['weight'] : '',
            isset($guaven_woos_pcv['width']) ? $guaven_woos_pcv['width'] : '',
            isset($guaven_woos_pcv['total_sales']) ? $guaven_woos_pcv['total_sales'] : '',
            isset($guaven_woos_pcv['stock_quantity']) ? $guaven_woos_pcv['stock_quantity'] : '',
            isset($guaven_woos_pcv['add_to_cart']) ? $guaven_woos_pcv['add_to_cart'] : '',
            isset($guaven_woos_pcv['product_cat']) ? $guaven_woos_pcv['product_cat'] : ''
        );
        if ($tip != 'persprod') {
            $replace[1] = '{{t}}';
            $replace[2] = str_replace($wpuploaddir['baseurl'], '{{u}}', $guaven_woos_pcv['thumb']);
        }

        if (!empty($guaven_woos_pcv['custom_fields'])) {
            foreach ($guaven_woos_pcv['custom_fields'] as $cs_key => $cs_value) {
                $find[]    = '{' . $cs_key . '}';
                $replace[] = $cs_value;
            }
        }

        $data = get_option('guaven_woos_layout');

        return str_replace($find, $replace, $data);
    }


    public function results_layout($tip, $gwsi, $gwid, $parsed)
    {
        $custom_layout = get_option('guaven_woos_results_layout');
        if (empty($custom_layout)) {
            $custom_layout = '<li class=\"guaven_woos_suggestion_list{guaven_woos_lay_tip}\" tabindex=\"{guaven_woos_lay_gwsi}\" id=\"prli_{guaven_woos_lay_id}\">  {guaven_woos_lay_parsed} </li>';
        }
        $scodes       = array(
            '{guaven_woos_lay_tip}',
            '{guaven_woos_lay_gwsi}',
            '{guaven_woos_lay_id}',
            '{guaven_woos_lay_parsed}'
        );
        $final_layout = str_replace($scodes, array(
            $tip,
            $gwsi,
            $gwid,
            $parsed
        ), $custom_layout);
        return $final_layout;
    }


    public function add_variations_metadata($parent_ID, $field)
    {
        global $wpdb;
        $ret        = '';
        $variations = $wpdb->get_results("select ID from $wpdb->posts where post_parent=" . esc_sql($parent_ID) . " and post_type='product_variation'");
        if (empty($variations)) {
            return;
        }
        foreach ($variations as $variation) {
            $tempstrarr = get_post_meta($variation->ID, $field, true);
            if (is_array($tempstrarr)) {
                $tempstrarr = json_encode($tempstrarr);
            }
            $ret .= ' ' . $tempstrarr;
        }
        return $ret;
    }

    public function admin_menu()
    {
        add_submenu_page('woocommerce', 'Guaven Woo Search', 'Search Engine', 'manage_options', __FILE__, array(
            $this,
            'run'
        ));
    }

    public function kses($str)
    {
        return esc_attr(stripslashes($str));
    }

    public function get_hidden_products()
    {
        global $wpdb;
        $excl_keys     = array();
        $final_exclude = array();
        $excludes1     = $wpdb->get_results("select term_id,name from $wpdb->terms where name='exclude-from-search' or name='exclude-from-catalog'");

        foreach ($excludes1 as $excl1) {
            $excludes2 = $wpdb->get_results("select object_id,term_taxonomy_id from $wpdb->term_relationships where term_taxonomy_id=" . ((int) $excl1->term_id));

            foreach ($excludes2 as $excl2) {
                $excl_keys[$excl1->name][] = $excl2->object_id;
            }
        }
        if (!empty($excl_keys['exclude-from-search']) and !empty($excl_keys['exclude-from-catalog'])) {
            $final_exclude = array_intersect($excl_keys['exclude-from-search'], $excl_keys['exclude-from-catalog']);
        }
        return $final_exclude;
    }

    public function fs_or_db()
    {
        if (get_option('guaven_woos_rebuild_via') != 'fs') {
            return;
        }
        return GUAVEN_WOO_SEARCH_PLUGIN_PATH . 'public/assets/guaven_woos_data_processing.js';
    }

    public function get_product_type($prdct)
    {
        if ($this->get_wc_version() < 3) {
            return $prdct->product_type;
        }
        return $prdct->get_type();
    }
    public function get_wc_version()
    {
        if (defined('WC_VERSION') and substr(WC_VERSION, 0, 1) == 3) {
            $guaven_woos_wooversion = 3;
        } else {
            $guaven_woos_wooversion = 2;
        }
        return $guaven_woos_wooversion;
    }

    public function translitter($str)
    {
        $specials           = array(
            "'",
            '"',
            'ä',
            'ö',
            'ü',
            'à',
            'â',
            'é',
            'è',
            'ê',
            'ë',
            'ï',
            'î',
            'ô',
            'ù',
            'û',
            'ÿ',
            'å',
            'ó',
            'ú',
            'ů',
            'ý',
            'ž',
            'á',
            'č',
            'ď',
            'ě',
            'í',
            'ň',
            'ř',
            'š',
            'ť',
            'ñ',
            'ç',
            'ğ',
            'ı',
            'İ',
            'ş',
            'ã',
            'õ',
            'ά',
            'έ',
            'ή',
            'ί',
            'ϊ',
            'ΐ',
            'ό',
            'ύ',
            'ϋ',
            'ΰ',
            'ώ',
            'ə',
            'а',
            'б',
            'в',
            'г',
            'д',
            'е',
            'ё',
            'ж',
            'з',
            'и',
            'й',
            'к',
            'л',
            'м',
            'н',
            'о',
            'п',
            'р',
            'с',
            'т',
            'у',
            'ф',
            'х',
            'ц',
            'ч',
            'ш',
            'щ',
            'ъ',
            'ы',
            'ь',
            'э',
            'ю',
            'я', //russian cyrillic
            'љ',
            'њ',
            'ѓ',
            'ќ',
            'џ',
            '-',
            'α',
            'β',
            'γ',
            'δ',
            'ε',
            'ζ',
            'η',
            'θ',
            'ι',
            'κ',
            'λ',
            'μ',
            'ν',
            'ξ',
            'ο',
            'π',
            'ρ',
            'ς',
            'τ',
            'υ',
            'φ',
            'χ',
            'ψ',
            'ω'
        );
        $specials_replacers = array(
            "",
            "",
            'a',
            'o',
            'u',
            'a',
            'a',
            'e',
            'e',
            'e',
            'e',
            'i',
            'i',
            'o',
            'u',
            'u',
            'y',
            'a',
            'o',
            'u',
            'u',
            'y',
            'z',
            'a',
            'c',
            'd',
            'e',
            'i',
            'n',
            'r',
            's',
            't',
            'n',
            'c',
            'g',
            'i',
            'i',
            's',
            'a',
            'o',
            'α',
            'ε',
            'η',
            'ι',
            'ι',
            'ι',
            'ο',
            'υ',
            'υ',
            'υ',
            'ω',
            'e',
            'a',
            'b',
            'v',
            'g',
            'd',
            'e',
            'io',
            'zh',
            'z',
            'i',
            'y',
            'k',
            'l',
            'm',
            'n',
            'o',
            'p',
            'r',
            's',
            't',
            'u',
            'f',
            'h',
            'c',
            'c',
            'sh',
            'sht',
            'a',
            'i',
            'y',
            'e',
            'yu',
            'ya',
            'lj',
            'nj',
            'g',
            'k',
            'dz',
            ' ',
            'a',
            'b',
            'g',
            'd',
            'e',
            'z',
            'h',
            'th',
            'i',
            'k',
            'l',
            'm',
            'n',
            'x',
            'o',
            'p',
            'r',
            's',
            't',
            'y',
            'f',
            'ch',
            'ps',
            'w'
        );
        $str                = mb_strtolower($str);
        return str_replace($specials, $specials_replacers, $str);
    }

    public function attribute_checkboxes($gws_wootags)
    {
        global $wpdb;
        $ret = ''; ?>
<li> <label><input type="checkbox" value="product_cat" <?php
        echo in_array('product_cat', $gws_wootags) ? 'checked' : ''; ?> />Product Categories</label></li>
<li> <label><input type="checkbox" value="product_tag" <?php
        echo in_array('product_tag', $gws_wootags) ? 'checked' : ''; ?> />Product Tags</label></li>
<?php
        $allatts = $wpdb->get_results("select * from " . $wpdb->prefix . "woocommerce_attribute_taxonomies");
        foreach ($allatts as $att) {
            echo '<li> <label><input type="checkbox" value="pa_' . $att->attribute_name . '"  ' . (in_array('pa_' . $att->attribute_name, $gws_wootags) ? 'checked' : '') . '/>Attribute "' . $att->attribute_label . '"</label></li>';
        }
    }

    private function trend_db_construct()
    {
        global $wpdb;
        $tablename = $wpdb->prefix . "woos_search_trends";
        $wpdb->query("
          DROP TABLE IF EXISTS `" . $tablename . "`;");
        $wpdb->query("CREATE TABLE `" . $tablename . "` (
      `ID` bigint(20) NOT NULL AUTO_INCREMENT,
      `post_id` bigint(20) NOT NULL,
      `search_count` int(11) NOT NULL,
      `user_info` varchar(100) NOT NULL,
      `point` tinyint(1) NOT NULL DEFAULT '1',
      `search_day` date NOT NULL,
      PRIMARY KEY (`ID`),
      UNIQUE KEY `post_id_search_day_user_info_point` (`post_id`,`search_day`,`user_info`,`point`)
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
    }
}
