<?php

if (!defined('ABSPATH')) {
    die;
}

class Guaven_woo_search_backend
{

    //cookie based search begin
    public function backend_search_filter($where = '')
    {
        if (strpos($where, 'product')===false) {
          return $where;
        }
        $search_query_local=$this->search_query();
        $is_woo                = 1;
        $where2                = $where;
        $backend_enable        = get_option('guaven_woos_backend');
        $found_posts           = $this->find_posts($backend_enable,$search_query_local);
        $checkkeyword          = $found_posts[0];
        $sanitize_cookie_final = $found_posts[1];

        if ($backend_enable != '' and !is_admin() and !empty($search_query_local) and $checkkeyword == strtolower(str_replace(array(
            "'",
            "-",
            "/",
            '"',
            "_"
        ), "", stripslashes($search_query_local))) and ((isset($_GET['post_type']) and $_GET['post_type'] == 'product') or get_option('guaven_woos_all_search') != '') //enable search.php to display the results
            ) {
            $leftpart   = explode(" ", $checkkeyword);
            $gsquery    = esc_attr($search_query_local); //get_search_query();
            $leftpart_2 = explode(" ", $gsquery);

            if (strpos(strtolower($where), $leftpart[0]) === false and strpos($where, $gsquery) === false and strpos($where, $leftpart_2[0]) === false) {
                return $where;
            }
            global $wpdb;
            if (empty($sanitize_cookie_final)) {
                $sanitize_cookie_final = 0;
            }
            $where .= " AND ( $wpdb->posts.ID in (" . $sanitize_cookie_final . ') )';
            $where=str_replace('?(.*)',' ',$where);
            $where2 = $this->query_cleaner(strtolower($where), $checkkeyword,$search_query_local);
            $where2 = $this->query_cleaner(strtolower($where2), $gsquery,$search_query_local);
            $where2=str_replace(strtolower($wpdb->prefix), $wpdb->prefix, $where2);

            $ignored_products = get_option('guaven_woos_excluded_prods');
            if (!empty($ignored_products)) {
                $where2 .= " and ($wpdb->posts.ID not in (" . esc_sql($ignored_products) . "))";
            }
        }
        return $where2;
    }


    public function backend_search_orderby($orderby_statement)
    {
        if (isset($_GET["orderby"])) {return $orderby_statement;}
        $backend_enable        = get_option('guaven_woos_backend');
        $search_query_local=$this->search_query();
        $found_posts           = $this->find_posts($backend_enable,$search_query_local);
        $checkkeyword          = $found_posts[0];
        $sanitize_cookie_final = $found_posts[1];


        if ($backend_enable != '' and !is_admin() and !empty($found_posts[1]) and !empty($search_query_local) and $checkkeyword == strtolower(str_replace(array(
            "'",
            "-",
            "/",
            '"',
            "_"
        ), "", stripslashes($search_query_local))) and ((isset($_GET['post_type']) and $_GET['post_type'] == 'product') or get_option('guaven_woos_all_search') != '')) {
            global $wpdb;
            $orderby_statement = "FIELD( $wpdb->posts.ID, " . $found_posts[1] . ") ASC";
        }
        return $orderby_statement;
    }


    public function find_posts($backend_enable,$search_query_local)
    {
        $sanitize_cookie = '';
        $checkkeyword    = '';

        if ($backend_enable == 1) {
            if (!empty($_COOKIE['prids_object_cookie'])) {
                $sanitize_cookie = preg_replace("/[^0-9,.]/", "", $_COOKIE['prids_object_cookie']);
            }
            if (!empty($_COOKIE['prids_keyword_cookie'])) {
                $checkkeyword = urldecode($_COOKIE['prids_keyword_cookie']);
            }
        } elseif ($backend_enable == 3 and !empty($search_query_local)) {
            $sanitize_cookie = preg_replace("/[^0-9,.]/", "", get_transient('gws_' . substr(str_replace(" ", "_", $search_query_local), 0, 166)));
            $checkkeyword    = mb_strtolower(urldecode(substr($search_query_local, 0, 166)));
        }

        if ($sanitize_cookie != '') {
            if (substr($sanitize_cookie, -1) != ',') {
                $sanitize_cookie = $sanitize_cookie . ',';
            }
            $sanitize_cookie_final = esc_sql(substr($sanitize_cookie, 0, -1));
        } else {
            $sanitize_cookie_final = '';
        }

        return array(
            $checkkeyword,
            $sanitize_cookie_final
        );
    }

    public function query_cleaner($where, $keyword,$search_query_local)
    {
        $keyword     = str_replace(array(
            '"'
        ), "", $keyword);
        $keyword_arr = explode(" ", $keyword);
        foreach ($keyword_arr as $kwkey => $kwvalue) {
            $where = str_replace(array(
                ']' . strtolower($kwvalue),
                '%' . $kwvalue . '%',
                strtolower($kwvalue) . '[',
                strtolower($kwvalue) . '{',
                '}' . strtolower($kwvalue)
            ), array(
                ']',
                '%%',
                '[',
                '{',
                '}'
            ), $where);
        }
        $keyword_arr = explode(" ", esc_sql($search_query_local));
        foreach ($keyword_arr as $kwkey => $kwvalue) {
            $where = str_replace(array(
                ']' . strtolower($kwvalue),
                '%' . strtolower($kwvalue) . '%',
                strtolower($kwvalue) . '[',
                strtolower($kwvalue) . '{',
                '}' . strtolower($kwvalue)
            ), array(
                ']',
                '%%',
                '[',
                '{',
                '}'
            ), $where);
        }
        $where = str_replace("AND post_title REGEXP '[[:<:]][[:>:]]'", "", $where);
        $where = str_replace("regexp '".strtolower($kwvalue)."'", "like '%%'", $where); //WOOF search query cleaner
        $where = str_replace("regexp '".strtolower($keyword)."'", "like '%%'", $where); //WOOF search query cleaner
        return $where;
    }
    //cookie based search end

    public function standalone_search_resetter($query)
    {
        if ($query->is_main_query() and isset($_GET["guaven_woos_stdnln"]) and !empty($_GET["s"])) {
            $query->set('s', "");
            $query->set('post_type', "");
        }
    }

    public function guaven_woos_pass_to_backend()
    {
        $sanitized_ids = preg_replace("/[^0-9,.]/", "", $_POST["ids"]);
        if (!empty($sanitized_ids)) {
            set_transient('gws_' . substr(str_replace(" ", "_", $_POST["kw"]), 0, 166), $sanitized_ids, 12 * 3600);
        } else set_transient('gws_' . substr(str_replace(" ", "_", $_POST["kw"]), 0, 166),'0,0', 12 * 3600);
        echo 'ok';
        die();
    }

    public function force_search_reload()
    {
        $search_query_local=$this->search_query();
        if (!empty($search_query_local) and !empty($_GET["post_type"]) and $_GET["post_type"] == 'product') {
            if (get_option('guaven_woos_backend') != 3) {
                return;
            }
            $transient_name = 'gws_' . substr(str_replace(" ", "_", $search_query_local), 0, 166);
            if (get_transient($transient_name) == '') {
                ?>
     <style>body {display: none !important}</style>
      <script>
      jQuery(document).ready(function(){
      gws_custom_submission=setInterval(function(){
      if (guaven_woos!=undefined){
          clearInterval(gws_custom_submission);
          guaven_woos_backend_preparer_direct('<?php echo esc_attr($search_query_local); ?>');
          }
      },200);});
      </script>
      <?php
            }
        }
    }

    public function search_query(){
      if (isset($_GET["s"])) {return $_GET["s"];}
      if (isset($_GET["woof_text"])) {return $_GET["woof_text"];}
      return;
    }
}
