<?php

if (!defined('ABSPATH')) {
    die;
}

class Guaven_woo_search_front
{
    private $cookieprods;
    public $js_css_version;

    public function __construct()
    {
        if (get_option('guaven_woos_ispers') != '') {
            $this->cookieprods = 1;
        }

        $this->js_css_version = (int) get_option('guaven_woos_jscss_version') + 1.903;
    }

    public function personal_interest_collector()
    {
        if (is_singular('product') and !empty($this->cookieprods)) {
            global $post;
            $products_personal = '';
            if (!empty($_COOKIE['guaven_woos_lastvisited'])) {
                $products_personal = get_transient($_COOKIE['guaven_woos_lastvisited']);
                $uniqcookieid      = $_COOKIE['guaven_woos_lastvisited'];
            } else {
                $uniqcookieid = 'guaven_woos_' . uniqid();
            }
            $guaven_woo_search_admin = new Guaven_woo_search_admin();
            $langfixer_arr           = $guaven_woo_search_admin->langfixer($post);
            $langfixer               = $langfixer_arr[0];
            $_product                = wc_get_product($post->ID);
            if (get_option('guaven_woos_taxes') != '') {
                $guaven_woos_taxenabled = 1;
            } else {
                $guaven_woos_taxenabled = 0;
            }

            $title_and_hidden_sku  = get_the_title($post->ID);
            $permalink_structure   = get_option('guaven_woos_permalink');
            $number_format         = get_option('guaven_woos_numberformat') != '' ? 0 : 2;
            $new_products_personal = $guaven_woo_search_admin->price_and_parparser($post, $langfixer, $_product, $guaven_woos_taxenabled, $title_and_hidden_sku, $permalink_structure, $number_format, 'thumbnail');
            $htmlkeys              = '<li class=\"guaven_woos_suggestion_list\" tabindex=\"' . $post->ID . '\">  ' . $guaven_woo_search_admin->parse_template($new_products_personal, 'persprod') . ' </li>';
            $products_personal     = str_replace($htmlkeys, '', $products_personal);
            $max_cookie_res_count  = get_option('guaven_woos_persmax') > 0 ? get_option('guaven_woos_persmax') : 5;
            $htmlkeys .= $products_personal;
            $htmlkeys_arr = explode('<li', $htmlkeys);
            if (count($htmlkeys_arr) > ($max_cookie_res_count + 1)) {
                $htmlkeys_arr = array_slice($htmlkeys_arr, 0, ($max_cookie_res_count + 1));
                $htmlkeys     = implode('<li', $htmlkeys_arr);
            }

            set_transient($uniqcookieid, $htmlkeys, 86400);
            setcookie('guaven_woos_lastvisited', $uniqcookieid, time() + 86400, '/', null, 0);
        }
    }

    public function enqueue()
    {
        if (get_option('guaven_woos_firstrun') != '') {
            $wpupdir               = wp_upload_dir();
            $guaven_woos_pure_home = explode("?", home_url());
            $enqname               = 'guaven_woos';
            wp_register_script($enqname, plugin_dir_url(__FILE__) . 'assets/' . $enqname . '.js', array(
                'jquery'
            ), $this->js_css_version, true);
            $guaven_woos_local_values = array(
                'focused' => 0,
                'backend' => (get_option('guaven_woos_backend') == 'checked' or get_option('guaven_woos_backend') == 1) ? 1 : (int) get_option('guaven_woos_backend'),
                'search_results' => home_url('/search-results'),
                'data_path' => plugin_dir_url(__FILE__) . 'assets/guaven_woos_data.js?v=' . $this->js_css_version,
                'engine_start_delay' => wp_is_mobile() ? 700 : 500,
                'highlight' => get_option('guaven_woos_highlight') != '' ? 1 : 0,
                'disable_meta_correction' => get_option('guaven_woos_disable_meta_correction') != '' ? 1 : 0,
                'show_all_text' => $this->get_string(get_option('guaven_show_all_text')),
                'showinit' => get_option('guaven_woos_showinit_t') != '' ? $this->get_string(get_option('guaven_woos_showinit_t'), 'html') : '',
                'shownotfound' => $this->get_string(get_option('guaven_woos_showinit_n'), 'html'),
                'populars_enabled' => get_option('guaven_woos_nomatch_pops') != '' ? 1 : 0,
                'categories_enabled' => get_option('guaven_woos_catsearch') != '' ? 1 : 0,
                'cmaxcount' => get_option('guaven_woos_catsearchmax') > 0 ? (int) get_option('guaven_woos_catsearchmax') : 5,
                'correction_enabled' => get_option('guaven_woos_corr_act') != '' ? 1 : 0,
                'pinnedtitle' => (get_option('guaven_woos_pinneds') != '' or get_option('guaven_woos_pinneds_cat') != '') ? $this->get_string(get_option('guaven_woos_pinnedt'), 'html') : '',
                'trendtitle' => get_option('guaven_woos_data_trend_num') != '0' ? $this->get_string(get_option('guaven_woos_trendt'), 'html') : '',
                'sugbarwidth' => get_option('guaven_woos_sugbarwidth') > 0 ? (round(get_option('guaven_woos_sugbarwidth') * 100) / 10000) : '1',
                'minkeycount' => get_option('guaven_woos_min_symb_sugg') > 0 ? (int) get_option('guaven_woos_min_symb_sugg') : 3,
                'maxcount' => get_option('guaven_woos_maxres') != '' ? (int) get_option('guaven_woos_maxres') : 10,
                'maxtypocount' => get_option('guaven_woos_whentypo') != '' ? (int) get_option('guaven_woos_whentypo') : 'maxcount',
                'large_data' => get_option('guaven_woos_large_data') > 0 ? (int) get_option('guaven_woos_large_data') : '0',
                'translit_data' => get_option('guaven_woos_translit_data'),
                'updir' => $wpupdir['baseurl'],
                'exactmatch' => get_option('guaven_woos_exactmatch') > 0 ? (int) get_option('guaven_woos_exactmatch') : '0',
                'perst' => ($this->cookieprods != '' and !empty($_COOKIE["guaven_woos_lastvisited"])) ? $this->get_string(get_option('guaven_woos_perst')) : '',
                'persprod' => ($this->cookieprods != '' and !empty($_COOKIE["guaven_woos_lastvisited"])) ? stripslashes($this->get_string(stripslashes(get_transient($_COOKIE["guaven_woos_lastvisited"])), 'html')) : '',
                'mobilesearch' => get_option('guaven_woos_mobilesearch') != '' ? 1 : 0,
                'wpml' => (defined('ICL_LANGUAGE_CODE') ? 'woolan_' . ICL_LANGUAGE_CODE : ''),
                'homeurl' => $guaven_woos_pure_home[0],
                'selector' => get_option('guaven_woos_selector') != '' ? stripslashes(get_option('guaven_woos_selector')) : '[name="s"]',
                'live_filter_selector' => get_option('guaven_woos_filter_selector') != '' ? stripslashes(get_option('guaven_woos_filter_selector')) : ''
            );
            if (get_option('guaven_woos_data_trend_num') != 0) {
                $guaven_woos_data_trend                  = $this->trend_calculator();
                $guaven_woos_local_values['trending'][0] = '{' . str_replace("'", "\'", $guaven_woos_data_trend[0]) . '}';
                $guaven_woos_local_values['trending'][1] = '{' . str_replace("'", "\'", $guaven_woos_data_trend[1]) . '}';
            }

            wp_localize_script($enqname, $enqname, $guaven_woos_local_values);
            wp_enqueue_script($enqname);
        }

        wp_enqueue_style('guaven_woos', plugin_dir_url(__FILE__) . 'assets/guaven_woos.css', array(), $this->js_css_version);
    }

    public function trend_calculator()
    {
        $ret   = get_transient('guaven_woos_data_trend');
        $count = get_option('guaven_woos_data_trend_num');
        if (empty($ret)
        // or current_user_can('manage_options')
            ) {
            $date_for_data       = get_option('guaven_woos_trend_days') > 0 ? get_option('guaven_woos_trend_days') : 3;
            $transient_life_time = get_option('guaven_woos_trend_refresh') > 0 ? (60 * get_option('guaven_woos_trend_refresh')) : 600;
            global $wpdb;
            $res       = $wpdb->get_results($wpdb->prepare("SELECT post_id,sum(point) say FROM " . $wpdb->prefix . "woos_search_trends " . "WHERE search_day>( CURDATE() - INTERVAL %d DAY ) " . "GROUP BY post_id ORDER BY say DESC limit %d", $date_for_data, $count));
            $trend_ids = array();
            foreach ($res as $key => $value) {
                $trend_ids[] = $value->post_id;
            }

            if (empty($trend_ids)) {
                return array(
                    '',
                    ''
                );
            }
            $args                      = array(
                'post_type' => 'product',
                'posts_per_page' => $count,
                'suppress_filters' => true,
                'post__in' => $trend_ids,
                'orderby' => 'post__in',
                'order' => 'desc'
            );
            $trend_get_posts           = get_posts($args);
            $guaven_woo_search_admin   = new Guaven_woo_search_admin();
            $guaven_woos_product_cache = $guaven_woo_search_admin->json_processing($trend_get_posts);
            $ret                       = $guaven_woo_search_admin->cache_li_loop(array_values($guaven_woos_product_cache));
            set_transient('guaven_woos_data_trend', serialize($ret), $transient_life_time);
        } else {
            $ret = unserialize($ret);
        }

        return $ret;
    }

    public function add_purchase_score_when_new_order($order_id)
    {
        $prods = array();
        if (defined('WC_VERSION') and substr(WC_VERSION, 0, 1) == 2) {
            $order = new WC_Order($order_id);
            $items = $order->get_items();
            foreach ($items as $item) {
                $prods[] = $item['product_id'];
            }
        } else {
            $order = wc_get_order($order_id);
            $items = $order->get_items();
            foreach ($items as $item) {
                $prods[] = $item->get_product_id();
            }
        }

        foreach ($prods as $key => $value) {
            $unid = (!empty($_COOKIE["gws_unid"]) and $_COOKIE["gws_unid"] != '') ? $_COOKIE["gws_unid"] : '';
            $this->guaven_woos_trend_inserter($value, $unid, 5);
        }
    }

    public function inline_js()
    {
        require_once plugin_dir_path(dirname(__FILE__)) . 'public/view.php';
    }

    public function kses($str)
    {
        return addslashes(wp_kses(stripslashes($str), array(
            'a' => array(
                'href' => array(),
                'class' => array()
            ),
            'img' => array(
                'src' => array(),
                'class' => array()
            ),
            'p' => array(
                'class' => array()
            ),
            'strong' => array(),
            'i' => array(),
            'del' => array(),
            'em' => array(),
            'ul' => array(),
            'ol' => array(),
            'li' => array(),
            'b' => array(),
            'br' => array(),
            'div' => array(
                'class' => array()
            ),
            'span' => array(
                'class' => array()
            ),
            'small' => array()
        )));
    }

    public function get_string($str, $stype = '')
    {
        if (strpos($str, 'wpml') === false) {
            return $stype == 'html' ? $this->kses($str) : esc_js($str);
        }

        if (defined('ICL_LANGUAGE_CODE')) {
            $filtered         = urldecode(html_entity_decode(esc_attr($str)));
            $strarr           = simplexml_load_string($filtered);
            $current_language = ICL_LANGUAGE_CODE;
            if (!empty($strarr->$current_language)) {
                return $stype == 'html' ? $this->kses($strarr->$current_language) : esc_js($strarr->$current_language);
            }
        }

        return $stype == 'html' ? $this->kses($str) : esc_js($str);
    }

    public function guaven_woos_tracker_inserter($failsuccess, $state, $froback, $unid)
    {
        $failed_arr                           = explode(", ", $failsuccess);
        $failed_arr_f[count($failed_arr) - 1] = $failed_arr[count($failed_arr) - 1];
        for ($i = count($failed_arr) - 2; $i >= 0; $i--) {
            if (strpos($failed_arr[$i + 1], $failed_arr[$i]) === false) {
                $failed_arr_f[$i] = $failed_arr[$i];
            }
        }

        $failed_arr_f = array_unique($failed_arr_f);
        global $wpdb;
        foreach ($failed_arr_f as $faf) {
            if (!empty($faf)) {
                $wpdb->insert($wpdb->prefix . "woos_search_analytics", array(
                    'keyword' => $faf,
                    'created_date' => date("Y:m:d"),
                    'user_info' => $unid,
                    'state' => $state,
                    'device_type' => (wp_is_mobile() ? 'mobile' : 'desktop'),
                    'side' => $froback
                ), array(
                    '%s',
                    '%s',
                    '%s',
                    '%s',
                    '%s'
                ));
            }
        }
    }

    public function guaven_woos_tracker_callback()
    {
        if (!isset($_POST["failed"]) or !isset($_POST["success"]) or !isset($_POST["corrected"]) or !isset($_POST["unid"])) {
            exit;
        }

        global $wpdb;
        $current_timestamp = time();
        $addcontrol        = esc_attr($_POST["addcontrol"]);
        if ($current_timestamp - intval($addcontrol) > 3600) {
            exit;
        }

        check_ajax_referer('guaven_woos_tracker_' . $addcontrol, 'ajnonce');
        $this->guaven_woos_tracker_inserter($_POST["failed"], 'fail', 'frontend', $_POST["unid"]);
        $this->guaven_woos_tracker_inserter($_POST["success"], 'success', 'frontend', $_POST["unid"]);
        $this->guaven_woos_tracker_inserter($_POST["corrected"], 'corrected', 'frontend', $_POST["unid"]);
        exit;
    }

    public function guaven_woos_trend_inserter($pid, $unid, $score = 1)
    {
        // if (current_user_can('manage_options') and $score==1) {
        //     return;
        // } //don't count admin visits
        global $wpdb;
        $wpdb->query($wpdb->prepare("
      INSERT INTO " . $wpdb->prefix . "woos_search_trends (post_id, search_count, user_info,point,search_day) VALUES(%d, 1, %s,%d,%s)
      ON DUPLICATE KEY UPDATE search_count=search_count+1", $pid, $unid, $score, date("Y-m-d")));
    }

    public function guaven_woos_trend_data()
    {
        if (!isset($_POST["pid"]) or !isset($_POST["unid"])) {
            exit;
        }
        $this->guaven_woos_trend_inserter($_POST["pid"], $_POST["unid"]);
        exit;
    }

    public function standalone()
    {
        require_once plugin_dir_path(dirname(__FILE__)) . 'public/standalone.php';
    }

}
