<?php
if ( ! defined( 'ABSPATH' ) ) exit;
/**
 * Footer Template
 *
*/
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
$test = $color = $repeat = $position = $size = $attachment = $result = '';
if( floris_get_option('custom_footer', 1) ) {
	$background_footer_array = floris_get_option('background_footer');
	$color = $background_footer_array['background-color'];
	$background_image = $background_footer_array['background-image'];
	$repeat = $background_footer_array['background-repeat'];
	$position = $background_footer_array['background-position'];
	$size = $background_footer_array['background-size'];
	$attachment = $background_footer_array['background-attachment'];
}
if( floris_get_option( 'top_footer_enable' ) && floris_get_option('custom_top_footer', 1) ) {
	$background_top_footer = floris_get_option('background_top_footer');
	$top_color = $background_top_footer['background-color'];
	$top_background_image = $background_top_footer['background-image'];
	$top_repeat = $background_top_footer['background-repeat'];
	$top_position = $background_top_footer['background-position'];
	$top_size = $background_top_footer['background-size'];
	$top_attachment = $background_top_footer['background-attachment'];
}

if (floris_get_option( 'top_footer_enable' ) && floris_get_option( 'top_footer_columns' )) {
	$top_footer_columns = floris_get_option( 'top_footer_columns' );
}else{
	$top_footer_columns = '25';
}

$footer_type = floris_get_option( 'footer-style' );
$button_lang = floris_get_option('button-lang');


$footer_lang = 0;
if( is_plugin_active('sitepress-multilingual-cms/sitepress.php') ){
	$sitepress_settings = get_option('icl_sitepress_settings');
	if(isset($sitepress_settings['icl_lang_sel_footer'])){
		$lang_footer = $sitepress_settings['icl_lang_sel_footer'];
		if( $lang_footer && $button_lang == '1' ){
			$footer_lang = 1;
		}
	}
}
?>
	    <footer>
	    	<?php if (floris_get_option( 'top_footer_enable' )): ?>
		    	<div class="top-footer f-col-<?php print wp_kses_post( $top_footer_columns ); ?>" <?php if( floris_get_option('custom_top_footer', 1) ){ print wp_kses_post( 'style="background-color:'.$top_color.'; background-image:url('.$top_background_image.'); background-repeat:'.$top_repeat.'; background-attachment:'.$top_attachment.'; background-position:'.$top_position.'; background-size:'.$top_size.';"' );} ?>>
		      		<div class="container">
		      			<?php dynamic_sidebar( 'footer' ); ?>
		      		</div>
		      	</div>
		    <?php endif ?>
	      	<div class="bottom-footer <?php if($footer_type == '2' && floris_get_option('custom_footer') == '0'){print wp_kses_post('footer-style-2');} ?>" <?php if( floris_get_option('custom_footer', 1) ){ print wp_kses_post( 'style="background-color:'.$color.'; background-image:url('.$background_image.'); background-repeat:'.$repeat.'; background-attachment:'.$attachment.'; background-position:'.$position.'; background-size:'.$size.';"' );} ?>>
		      	<div class="container">
		      	  	<div class="footer">
				      	<?php if( floris_get_option('footer_social', 1) ) { ?>
			                <div class="footer-folow share-link">
			                	<?php 
			                		$social = floris_get_option('soc-slides');
			                		if( ! empty( $social) ) {
						            foreach ( $social as $val )
						            	if($val['url'] && $val["description"]) {
						            		print wp_kses_post( '<a href="'.esc_url( $val["url"] ).'" target="_blank"><i class="'.$val["description"].'"></i><i class="'.$val["description"].'"></i></a>' );
						            	}
						        } ?>
			                </div>
			            <?php } ?>
			            <?php
			                if( $button_lang == '2' ){
		                        do_action('wpml_add_language_selector');
		                    }
				            if( floris_get_option('footer_menu', 1) ){
		                        if ( function_exists( 'has_nav_menu' ) && has_nav_menu( 'footer-menu' ) ) {
		                            wp_nav_menu( array( 'theme_location' => 'footer-menu',
		                                                'container'      => 'ul',
		                                                'menu_class'	 => 'footer-nav',
		                                                'sort_column'    => 'menu_order',
		                                                'depth'          => 0
		                            ) );
		                        } else {
		                            esc_html_e( 'Please assign footer menu in Appearance->Menus', 'floris' );
		                        }
		                    }
	                    ?>
		             	<div class="copyright"><span>
		             		<?php 
		             			if( floris_get_option('footer_right', 1) ) {
									print wp_kses_post( floris_get_option('footer_right_text') );
								} 
							?></span>
						</div>
						<?php print wp_kses_post( ( $footer_lang ? '<div class="footer_message">Please, enable Themes Options->General Settings->Switch language->footer</div>' : '' ) ); ?>
		           	</div>  
		      	</div>
	      	</div>
      	</footer>

     	<!--==========CHECKOUT============-->
     <?php if (!floris_get_option('catalog_mode')): ?>
     	
     	<div class="check-out popup mark-popup-2">
     		<div class="close-popup"><span></span></div>
 			<div class="check-content">
 				<div id="fl-mini-cart-loader">
 					<div class="fl-loader"><?php esc_html_e( 'Updating...', 'floris' ); ?>
 						<div class="loader-wrapper button_load"><div class="loader-inner ball-pulse"><div></div><div></div><div></div></div></div>
 					</div>
 				</div>
 				<div class="widget_shopping_cart cart_ajax">
 					<div>
	 					<?php
	 						if( class_exists( 'WooCommerce' ) ) { 
		 						woocommerce_mini_cart();
		 					} else { 
						       	esc_html_e( 'WooCommerce not Activated!', 'floris' );
						    } ?>
		 				?> 
	 				</div>
 				</div>
 			</div>
     	</div> 
    <?php endif ?>  
    <?php 
    if ( floris_get_option('back_top') ) { ?>
		<div id="btt"><i class="fa fa-angle-up"></i></div>
	<?php }
	//photoswipe
	if( is_singular( 'product' ) ){ ?>
		<div class="pswp" tabindex="-1" role="dialog" aria-hidden="true">
		    <div class="pswp__bg"></div>
		    <div class="pswp__scroll-wrap">
		        <div class="pswp__container">
		            <div class="pswp__item"></div>
		            <div class="pswp__item"></div>
		            <div class="pswp__item"></div>
		        </div>
		        <div class="pswp__ui pswp__ui--hidden">
		            <div class="pswp__top-bar">
		                <div class="pswp__counter"></div>
		                <button class="pswp__button pswp__button--close" title="<?php esc_html_e('Close (Esc)', 'floris'); ?>"></button>
		                <button class="pswp__button pswp__button--fs" title="<?php esc_html_e('Toggle fullscreen', 'floris'); ?>"></button>
		                <button class="pswp__button pswp__button--zoom" title="<?php esc_html_e('Zoom in/out', 'floris'); ?>"></button>
		                <div class="pswp__preloader">
		                    <div class="pswp__preloader__icn">
		                      	<div class="pswp__preloader__cut">
		                        	<div class="pswp__preloader__donut"></div>
		                      	</div>
		                    </div>
		                </div>
		            </div>
		            <div class="pswp__share-modal pswp__share-modal--hidden pswp__single-tap">
		                <div class="pswp__share-tooltip"></div> 
		            </div>
		            <button class="pswp__button pswp__button--arrow--left" title="<?php esc_html_e('Previous (arrow left)', 'floris'); ?>"></button>
		            <button class="pswp__button pswp__button--arrow--right" title="<?php esc_html_e('Next (arrow right)', 'floris'); ?>"></button>
		            <div class="pswp__caption">
		                <div class="pswp__caption__center"></div>
		            </div>
		        </div>
		    </div>
		</div>
	<?php 
	}
	if (floris_get_option('header_login') && !is_user_logged_in()) : ?>
		<div id="login-modal" class="login-modal woocommerce-account">
	        <div class="modal-header"> 
	            <div class="close-popup"><span></span></div>
	        </div>
	        <div class="modal-content">
	            <div class="container">
	                <div class="woocommerce">
	                    <h2 class="text-center login-tabs-nav tabs-nav"> <span class="line-hover tab-nav active" data-tab="login"><?php esc_html_e( 'Login', 'floris' ); ?></span> <span class="line-hover tab-nav" data-tab="register"><?php esc_html_e( 'Register', 'floris' ); ?></span></h2>
	                    <div class="u-columns col2-set tab-panels" id="customer_login">
	                        <div class="u-column1 col-1 tab-panel active" data-tab="login">
	                            <form method="post" class="login">
	                                <?php do_action( 'woocommerce_login_form_start' ); ?>
	                                    <p class="woocommerce-FormRow woocommerce-FormRow--wide form-row form-row-wide"> 
	                                        <label for="username"><?php esc_html_e( 'Username', 'floris' ); ?></label> 
	                                        <input type="text" class="woocommerce-Input woocommerce-Input--text input-text" name="username" id="username" value="<?php if ( ! empty( $_POST['username'] ) ) print esc_attr( $_POST['username'] ); ?>" required="">
	                                    </p>
	                                    <p class="woocommerce-FormRow woocommerce-FormRow--wide form-row form-row-wide">
	                                        <label for="password"><?php esc_html_e( 'Password', 'floris' ); ?></label> 
	                                        <input class="woocommerce-Input woocommerce-Input--text input-text" type="password" name="password" id="password" required="">
	                                    </p>
	                                    <p class="form-row"> 
	                                        <?php wp_nonce_field( 'woocommerce-login', 'woocommerce-login-nonce' ); ?>
	                                        <label class="inline"> 
	                                            <input class="woocommerce-Input woocommerce-Input--checkbox" name="rememberme" type="checkbox" id="rememberme" value="forever"> 
	                                            <span class="sb-checkbox"><?php esc_html_e( 'Remember me', 'floris' ); ?></span>
	                                        </label>
	                                    </p>
	                                    <?php do_action( 'woocommerce_login_form' ); ?>
	                                    <p class="form-row"> 
	                                        <input type="submit" class="woocommerce-Button button" name="login" value="Login">
	                                        <a href="#" class="button-style" ><span><?php esc_html_e( 'Login', 'floris' ); ?></span></a>
	                                    </p>
	                                    <p class="woocommerce-LostPassword lost_password"> 
	                                        <a href="/my-account/lost-password/"><?php esc_html_e( 'Lost your password?', 'floris' ); ?></a>
	                                    </p>
	                                <?php do_action( 'woocommerce_login_form_end' ); ?>
	                            </form>
	                        </div>
	                        <div class="u-column2 col-2 tab-panel" data-tab="register">
	                            <form method="post" class="register">
	                            <?php do_action( 'woocommerce_register_form_start' ); ?>

	                            <p class="woocommerce-FormRow woocommerce-FormRow--wide form-row form-row-wide"> 
	                                <label for="reg_email"><?php print esc_html_e( 'Email address', 'floris' ); ?></label> 
	                                <input type="email" class="woocommerce-Input woocommerce-Input--text input-text" name="email" id="reg_email" value="<?php if ( ! empty( $_POST['email'] ) ) print esc_attr( $_POST['email'] ); ?>" required="">
	                            </p>
	                            <p class="woocommerce-FormRow woocommerce-FormRow--wide form-row form-row-wide">
	                                <label for="reg_password"><?php esc_html_e( 'Password', 'floris' ); ?></label> 
	                                <input type="password" class="woocommerce-Input woocommerce-Input--text input-text" name="password" id="reg_password" required="">
	                            </p>
	                            <?php do_action( 'woocommerce_register_form' ); ?>
	                            <p class="woocomerce-FormRow form-row"> 
	                                <?php wp_nonce_field( 'woocommerce-register', 'woocommerce-register-nonce' ); ?>
	                                <input type="submit" class="woocommerce-Button button" name="register" value="Register">
	                                <a href="#" class="button-style" ><span><?php esc_html_e( 'Register', 'floris' ); ?></span></a>
	                            </p>
	                            <!-- Spam Trap -->
	                            <div style="<?php echo ( ( is_rtl() ) ? 'right' : 'left' ); ?>: -999em; position: absolute;"><label for="trap"><?php esc_html__( 'Anti-spam', 'floris' ); ?></label><input type="text" name="email_2" id="trap" tabindex="-1" autocomplete="off" /></div>
	                            <?php do_action( 'woocommerce_register_form_end' ); ?>
	                            </form>
	                        </div>
	                    </div>
	                </div>
	            </div>
	        </div>
	    </div>
<?php 
	endif; 
	wp_footer(); 
?>
	</body>
</html>