<?php
//Banner Grid for VC
// Parent Element
function floris_banner_grid_vc() {
    vc_map( 
        array(
            "icon" => 'floris-banner',
            'name'                    => esc_html__( 'Banner Grid' , 'floris' ),
            'base'                    => 'floris_banner_grid_shortcode',
            'description'             => esc_html__( 'Create Banner Grid', 'floris' ),
            'as_parent'               => array('only' => 'floris_banner_grid_content_shortcode'), 
            'content_element'         => true,
            "js_view" => 'VcColumnView',
            "category" => esc_html__('Floris', 'floris'),
            'params'          => array(
                array(
                    'heading'     => esc_html__( 'Grid Style', 'floris' ),
                    'description' => esc_html__( 'Select Grid Style', 'floris' ),
                    'type'        => 'dropdown',
                    'param_name'  => 'layout',
                    'value'       => array(
                        esc_html__( 'Grid 4', 'floris' )  => 'grid_4',
                        esc_html__( 'Grid 5', 'floris' )  => 'grid_5',
                        esc_html__( 'Grid 6', 'floris' )  => 'grid_6',
                    ),
                ),
                array(
                    'type' => 'checkbox',
                    'heading' => esc_html__( 'Reverse order', 'floris' ),
                    'param_name' => 'reverse_order',
                    'default' => false,
                    'dependency'  => array( 'element' => 'layout', 'value' => array('grid_4','grid_6') )
                ), 
            )
        )
    );
}
add_action( 'vc_before_init', 'floris_banner_grid_vc' );

// Nested Element
function floris_banner_grid_content_vc() {
    
    vc_map(
        array(
            "icon" => 'floris-cat-single',
            'name'            => esc_html__('Banner Grid Item', 'floris'),
            'base'            => 'floris_banner_grid_content_shortcode',
            'description'     => esc_html__( 'Content Item', 'floris' ),
            "category" => esc_html__('Floris', 'floris'),
            'content_element' => true,
            'as_child'        => array('only' => 'floris_banner_grid_shortcode'), 
            'params'          => array(
                
                array(
                    'heading'     => esc_html__( 'Images', 'floris' ),
                    'description' => esc_html__( 'Item Images', 'floris' ),
                    'param_name'  => 'image',
                    'type'        => 'attach_images',
                ),
                array(
                    'heading'     => esc_html__( 'Transition speed', 'floris' ),
                    'description' => esc_html__( 'If you have a few images in Images field, here you can set transition speed (ms) for the slider. For example: 1000', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'image_transition',
                    'value'       => '500',
                ),
                array(
                    'heading'     => esc_html__( 'Image size', 'floris' ),
                    'description' => esc_html__( 'Enter image size. Example: "thumbnail", "medium", "large", "full" or other sizes defined by current theme. Alternatively enter image size in pixels: 200x100 (Width x Height). Leave empty to use "thumbnail" size.', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'image_size',
                    'value'       => '',
                ),
                array(
                    'heading'     => esc_html__( 'Image padding', 'floris' ),
                    'description' => esc_html__( 'Enter image paddings. Example in pixels: 15px or 20px 40px (top/bottom and left/right paddings).', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'image_paddings',
                    'value'       => '',
                ),
                array(
                    'heading'     => esc_html__( 'Add modal video', 'floris' ),
                    'type'        => 'dropdown',
                    'param_name'  => 'modal_video',
                    'value'       => array(
                        esc_html__( 'No', 'floris' )   => 'false',
                        esc_html__( 'Yes', 'floris' ) => 'true',
                    ),
                ),
                array(
                    'heading'     => esc_html__( 'Video type', 'floris' ),
                    'description' => esc_html__( 'Select video type', 'floris' ),
                    'type'        => 'dropdown',
                    'param_name'  => 'video_type',
                    'value'       => array(
                        esc_html__( 'Youtube', 'floris' )   => 'youtube',
                        esc_html__( 'Vimeo', 'floris' ) => 'vimeo',
                    ),
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('true') )
                ),
                array(
                    'heading'     => esc_html__( 'Video ID', 'floris' ),
                    'description' => esc_html__( 'Enter video ID', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'video_id',
                    'admin_label' => true,
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('true') )
                ), 
                array(
                    'heading'     => esc_html__( 'Item Text', 'floris' ),
                    'description' => esc_html__( 'Enter banner text', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'text',
                    'admin_label' => true,
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('false') )
                ),
                array(
                    'heading'     => esc_html__( 'Font size', 'floris' ),
                    'description' => esc_html__( 'Enter font size', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'font_size',
                    'admin_label' => true,
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('false') )
                ),
                array(
                    'heading'     => esc_html__( 'Line height', 'floris' ),
                    'description' => esc_html__( 'Enter line height', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'line_height',
                    'admin_label' => true,
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('false') )
                ),
                array(
                    'heading'     => esc_html__( 'Horisontal Item Text Position', 'floris' ),
                    'description' => esc_html__( 'Select horisontal text position', 'floris' ),
                    'type'        => 'dropdown',
                    'param_name'  => 'text_align',
                    'value'       => array(
                        esc_html__( 'Left', 'floris' )   => 'left',
                        esc_html__( 'Center', 'floris' ) => 'center',
                        esc_html__( 'Right', 'floris' )  => 'right',
                    ),
                ),
                array(
                    'heading'     => esc_html__( 'Verical Item Text Position', 'floris' ),
                    'description' => esc_html__( 'Select vertical text position', 'floris' ),
                    'type'        => 'dropdown',
                    'param_name'  => 'v_text_align',
                    'value'       => array(
                        esc_html__( 'Top', 'floris' )   => 'top',
                        esc_html__( 'Middle', 'floris' ) => 'middle',
                        esc_html__( 'Bottom', 'floris' )  => 'bottom',
                    ),
                ),
                array(
                    'heading'    => esc_html__( 'Link (URL)', 'floris' ),
                    'type'       => 'vc_link',
                    'param_name' => 'link',
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('false') )
                ),
                array(
                    'heading'     => esc_html__( 'Button Text', 'floris' ),
                    'description' => esc_html__( 'Enter the text for banner button', 'floris' ),
                    'type'        => 'textfield',
                    'param_name'  => 'button_text',
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('false') )
                ),
                array(
                    'heading'     => esc_html__( 'Item Text Color Style', 'floris' ),
                    'description' => esc_html__( 'Select vertical text position', 'floris' ),
                    'type'        => 'dropdown',
                    'param_name'  => 'text_color_style',
                    'value'       => array(
                        esc_html__( 'Dark', 'floris' )   => 'dark',
                        esc_html__( 'Light', 'floris' ) => 'light',
                    ),
                ),
                array(
                    'type' => 'checkbox',
                    'heading' => esc_html__( 'Enable text hover effect', 'floris' ),
                    'param_name' => 'dinamic_hover_text',
                    'default' => true,
                    'dependency'  => array( 'element' => 'modal_video', 'value' => array('false') )
                ), 
                array(
                    'type' => 'checkbox',
                    'heading' => esc_html__( 'Enable background hover effect', 'floris' ),
                    'param_name' => 'dinamic_hover_bg',
                    'default' => false
                ),  
                vc_map_add_css_animation(),
                array(
                    'heading'     => esc_html__( 'Extra class name', 'floris' ),
                    'description' => esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'floris' ),
                    'param_name'  => 'el_class',
                    'type'        => 'textfield',
                    'value'       => '',
                ),

            ),
        ) 
    );
}
add_action( 'vc_before_init', 'floris_banner_grid_content_vc' );

// A must for container functionality, replace Wbc_Item with your base name from mapping for parent container
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortCode_floris_banner_grid_shortcode extends WPBakeryShortCodesContainer {

    }
}

// Replace Wbc_Inner_Item with your base name from mapping for nested element
if(class_exists('WPBakeryShortCode')){
    class WPBakeryShortCode_floris_banner_grid_content_shortcode extends WPBakeryShortCode {

    }
}