<?php
if ( ! defined( 'ABSPATH' ) ) { die( '-1' ); }
/*
 *
 * Posts for VC
 *
 */


function floris_post_fn_vc() {
	vc_map(
		array(
			"icon" => 'floris-posts',
			"name" => esc_html__("Blog posts", 'floris'),
			"base" => "floris_post_shortcode",
			'description' => esc_html__( 'Related post', 'floris' ),
			"category" => esc_html__('Floris', 'floris'),
			"params" => array (
				array(
                    'type' => 'dropdown',
                    'heading' => esc_html__('Blog style', 'floris'),
                    'param_name' => 'blog_style',
                    'value' => array(
                        esc_html__( 'Style 1', 'floris') => 'style_1',
                        esc_html__( 'Style 2', 'floris') => 'style_2',
                    )
                ),
				array(
                    'type' => 'textfield',
                    'heading' => esc_html__( 'Block title', 'floris' ),
                    'param_name' => 'title',
                    'value' => '',
                    'admin_label' => true,
                    'description' => esc_html__( 'Blog post section title.', 'floris' )
                ),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Items per page', 'floris' ),
					'param_name' => 'amount',
					'value' => '',
					'description' => esc_html__( 'Enter items per page', 'floris' )
				),
				array(
                    'type' => 'css_editor',
                    'heading' => esc_html__('Css', 'floris'),
                    'param_name' => 'css',
                    'group' => esc_html__('Design options', 'floris'),
                ),
                array(
					'type'     => 'checkbox',
					'heading' => esc_html__( 'Hide post\'s title', 'floris' ),
					'save_always' => true,
					'param_name' => 'hide_title',
					'default' => false
				),
                array(
					'type'     => 'checkbox',
					'heading' => esc_html__( 'Hide post\'s short description', 'floris' ),
					'save_always' => true,
					'param_name' => 'hide_description',
					'default' => false
				),
				array(
					'type'     => 'checkbox',
					'heading' => esc_html__( 'Hide post\'s date', 'floris' ),
					'save_always' => true,
					'param_name' => 'hide_date',
					'default' => false
				),
			)
		)
	);
	
}
add_action( 'vc_before_init', 'floris_post_fn_vc' );

if(class_exists('WPBakeryShortCode')) {
	class WPBakeryShortCode_floris_post_shortcode extends WPBakeryShortCode {
	}
}