<?php
/*
 *
 * Banner Grid Item shortcode for VC
 *
 */

$image = $image_size = $modal_video = $video_type = $video_id = $text = $font_size = $line_height = $text_align = $v_text_align = $link = $button_text = $dinamic_hover_text = $dinamic_hover_bg = $text_color_style = $css_animation = $el_class = $image_paddings = $image_transition = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

$css_class = array(
	'item-banner',
	'text-align-' . $text_align,
	'v-text-align-' . $v_text_align,
	'text-style-' . $text_color_style,
	self::getCSSAnimation( $css_animation ),
	$el_class,
);
if (!$dinamic_hover_text) {
	$css_class[] = 'static-hover';
}
if ($dinamic_hover_bg) {
	$css_class[] = 'bg-hover';
}
$inline_styles = '';
$inline_btn_styles = '';

if ($font_size) {
	$inline_styles .= 'font-size: '.$font_size.'; ';
	preg_match_all('!\d+!', $font_size, $matches_num);
	$val = intval($matches_num[0][0])/2;
	$px = preg_replace('/[0-9]+/', '', $font_size);
	$inline_btn_styles .= 'font-size: '.$val.$px.';';
}
if ($line_height) {
	$inline_styles .= 'line-height: '.$line_height.';';
}


$link = vc_build_link( $link );

$image_html = '';
$images = $image;

if ($images) {
	$images = explode(',', $images);
	if (count($images) <= 1) {
		$image_html = get_grid_image($images[0], $image_size);
	}else{
		$image_transition = $image_transition ? $image_transition : '500';
		$image_html .= '<div class="grid-animation-slider" data-autoplay="'.esc_attr( $image_transition ).'">
							<div class="swiper-wrapper">';
		foreach ($images as $image) {
			$image_html .= '<div class="swiper-slide">'.get_grid_image($image, $image_size).'</div>';
		}	
		$image_html .=		'</div>
						</div>';				
	}
}

?>
<div class="<?php print esc_attr( implode( ' ', $css_class ) ); ?>" style="padding: <?php print esc_attr( $image_paddings ); ?>;">
	<?php if ($modal_video == 'true'): ?>
		<a href="javascript:void(0);" class="js-modal-video-btn" data-video-id="<?php print esc_attr( $video_id ); ?>" data-channel="<?php print esc_attr( $video_type ); ?>">
			<?php print $image_html; ?>
			<span class="banner-content">
				<div class="play-button"><i class="icon-play"></i></div>
			</span>
		</a>
	<?php else: ?>
		<a href="<?php print esc_url( $link['url'] ); ?>" target="<?php print esc_attr( $link['target'] ); ?>" rel="<?php print esc_attr( $link['rel'] ); ?>" title="<?php print esc_attr( $link['title'] ); ?>">
			<?php print $image_html; ?>
			<span class="banner-content">
				<span class="banner-text" style="<?php print esc_attr( $inline_styles ); ?>"><?php print esc_html( $text ); ?></span>
				<span class="item-button button-light line-hover active" style="<?php print esc_attr( $inline_btn_styles ); ?>"><?php print esc_html( $button_text ); ?></span>
			</span>
		</a>
	<?php endif; ?>
</div>